\ Clean Songlist - for the Digital Piano -- include 3iPiano.fs  

\ TODO: ADD REST NOTATIONS
\ TODO: FIX - leave doesn't work
\ Design: this plays by reading notes or directly e.g. 1 .. 2 .. 3 ..

\ Design: this songlist plays music in an easy to read 1-8 notation with #/% for sharp/flat and <</>> for octave down/up
\ Design: by default index is to middle c  (C_ to C' 13-key keyboards)
\ Design: offset 8+ is required for 32-key keyboards (F__ to C'')
\ MUSICAL NOTATION FOR SONGLIST.fs
\ 1 2 ... 8 notation for white keys indexed to middle c_
create cmaj-map \ maps 1...8 to the c-major keys (white keys) followed by the black keys \ formerly called scale-led-map
    0 c, 2 c, 4 c, 5 c, 7 c, 9 c, 11 c, 12 c, ( white keys ) 1 c, 3 c, 6 c, 8 c, 10 c, 13 c, ( black keys )
\ Sharps and Flats based on the 8-key numbering, with sharps and flats.
9  constant 1#
9  constant 2%
10 constant 2#
10 constant 3%
11 constant 4#
11 constant 5%
12 constant 5#
12 constant 6%
13 constant 6#
13 constant 7%
14 constant 8#
15 constant <<
16 constant >>
variable scaleroot 
: scaleroot! ( note-name -- ) scaleroot ! ;
: scaleroot@ ( -- note-name ) scaleroot @ ;
: init-scaleroot  c_ scaleroot! ; \ default middle c  test: init-scaleroot scaleroot@ note
init-scaleroot
: [<<] scaleroot@ 12 - scaleroot! ; \ raise octave
: [>>] scaleroot@ 12 + scaleroot! ; \ lower octave   test: [>>] scaleroot@ note
: [,,]   ( playlist# -- adjscalenote# ) 1 - scale + c@ ;
: [,,,]  ( playlist# -- 0index# ) 1 - scale + c@ c_ - ;  \ use for playing a different scale
: [...]  ( playlist# -- 0index# ) 1 - cmaj-map + c@ ;  \ transforms playlist notation to sequential notes 0-indexed
\  Design: on 13-key keyboard seq# 0-12 is middle c scale.
\  Design: on 32-key F__ to C'' keyboard seq# is -7 to 24  (piano-led board)
: adjust-octave  ( 15/16 --  ) >> - if [<<] else [>>] then ;

: _key           ( -- 0/1 )      key esc-key = if leave then ;  \ BUG!!! CODE REVIEW: NEED TO FIX  TODO
: _sound         ( 0index# -- )  scaleroot@ + note ;   \ transform to note# (3iSound-4x4.fs) and plays note
: _light         ( 0index# -- )  scaleroot@ 36 - 8 + + kk ;              \ transform to light# (3iPianoLights.fs) and turns on light
: _soundlight    ( 0index# -- )  dup _light _sound ;
: _soundlightkey ( 0index# -- )  _soundlight _key ; \ advance on keypress, ESC to stop
: _lightkey      ( 0index# -- )  _light _key ;
: _soundkey      ( 0index# -- )  _sound _key ;

variable playmode
0 constant  soundonly
1 constant  lightonly
2 constant  soundlight
3 constant  soundlightkey
4 constant  lightkey
5 constant  soundkey
: playmode!  ( choice -- ) playmode ! ;
soundonly playmode!  \ default at startup
: playmode@  ( -- choice ) playmode @ ;
create playmode-map   ' _sound , ' _light , ' _soundlight , ' _soundlightkey , ' _lightkey , ' _soundkey ,
  \ Design: .. doesn't always sound a note, if << or >> then it adjusts the octave and stops as the next note needs to be rolled in from the stack
: .. ( playlist# -- ) dup 8# > if adjust-octave else [,,,] playmode@ cells playmode-map + @ execute then ;

\ CODE REVIEW: Get to a musical data structure -- 3 arrays
\ play directly from stack, left to right

\   Design: core musical dependency is 3iSound-4x4.fs which has the notational transformation required
\   Design: audio only
: [play] init-scaleroot dup 0 do dup i - roll .. loop drop ;
: play  ( num-notes -- ) soundonly playmode! [play] ;
: watch ( num-notes -- ) 32-clear soundlight playmode! [play] 32-clear ;
: learn ( num-notes -- ) 32-clear soundlightkey playmode! [play] 32-clear ;
: listenstep ( num-notes -- ) soundkey playmode! [play] ;
: lightstep  ( num-notes -- ) 32-clear lightkey playmode! [play] 32-clear ;


\   Design: audio + lights
\  : watch ( n -- ) dup 0 do dup i - roll dup #_ .. loop drop 32-clear ;   \ see 3iPianoLights.fs for kk
\  : watch ( n -- ) dup 0 do dup i - roll #__ 500 ms light| 100 ms loop drop light| ;   \ see 3iPort-4x4.fs for light_

\   Design: learn each note and use PC to prompt next note --- LATER: read key to check it's the right one being pressed
\ : learn ( n -- ) dup 0 do dup i - roll dup #_ .. key drop loop drop 32-clear ;
\ : learn ( n -- ) init-scaleroot dup 0 do dup i - roll .. key drop loop drop 32-clear ;

\ TO DO: add ESC to play rest.  Add back key to go back.  Add play a phrase key.
\ TO DO: how to flash?


\ Classical Pieces
\ https://www.youtube.com/watch?v=VfPGNafN8K8
\ https://www.google.com/search?client=firefox-b-d&q=simple+classical+tunes

: new-harp
   cstd
   3 2 1 2 3 5 5 4 4
   4 3 2 3 4 6 6 5 5
   3 2 1 2 3 5 5 4 4
   4 3 2 4 3 2 3 1 1
   8 7 6 5 8 7 6 5 8 7 6 5 4 3 2
   7 6 5 7 6 5 7 6 5 4 3 2 1
64
; 

\ Beethoven's Ode to Joy
: ode
    cstd
    3 3 4 5 5 4 3 2 1 1 2 3 3 2 2 
    3 3 4 5 5 4 3 2 1 1 2 3 2 1 1 
    2 2 3 1 2 3 4 3 1 2 3 4 3 2 1 2 << 5 >>
    3 3 4 5 5 4 3 2 1 1 2 3 2 1 1
64
;

\ Bach: Jesu, Joy of Man's Desiring  (Jesu, bleibet meine Freude) BWV 147/10, Last chorus of the cantata Herz und Mund und Tat und Leben BWV 147, 14:13
\ https://www.youtube.com/watch?v=6ZKGD2IIhjk
\ Cello, Guitar Duo: https://www.youtube.com/watch?v=KialZHRdD7A
\ Piano (liquid legato): https://www.youtube.com/watch?v=uKq5IcBFyeQ
\ Organ: https://www.youtube.com/watch?v=2uXn6nDN7ck    
\ Jesus, joy of man's desiring 
\ Holy wisdom, love most bright 
\ Drawn by Thee, our souls aspiring Soar to uncreated light 
\ Word of God, our flesh that fashioned 
\ With the fire of life impassioned 
\ Striving still to Truth unknown Soaring, dying 'round Thy throne
: jesu-c
  cstd
  1 2 3 5 4 4 6 5 5 8 7 8 5 3 1 2 3 4 2 << 7  5 6 7 >>
  1 2 3 5 4 4 6 5 5 8 7 8 5 3 1 2 3 4 5 6 5 3 2 << 5 >> 1 << 7 >> 1
  56
;

: jesu-g
  cstd
  5 6 7 >> 2 1 1 3 2 2 5 4# 5 2 << 7 5 6 7 8 6 5 2 5 4# 5
  26
;

\ Fur Elise
\ https://www.sheetmusicdirect.com/en-US/se/ID_No/433968/Product.aspx
: elise
  cstd
  >> 
  3 2# 3 2# 3 << 7 >> 2 1 << 6
  << 3 6  >> 1 3 6 7     3 5# 7 >> 1
  3 2# 3 2# 3 << 7 >> 2 1 << 6
  << 3 6  >> 1 3 6 7     3 >> 1 << 7 6
  
  7 >> 1 2 3 << 3 >> 4 3 2 << 3 >> 3 2 1  << 3 >> 2 1 << 7 >> 3  

  3 2# 3 2# 3 << 7 >> 2 1 << 6
  << 3 6  >> 1 3 6 7     3 5# 7 >> 1
  3 2# 3 2# 3 << 7 >> 2 1 << 6
  << 3 6  >> 1 3 6 7     3 >> 1 << 7 6
129 
;


\ Pachelbel: Canon in D, 00:00 - 4:45
\ https://www.sheetmusicdirect.com/en-US/se/ID_No/103307/Product.aspx


\ Beethoven: Moonlight Sonata


\ FAMOUS POP TUNES

: memory
    cstd
    8 8 
    7 8 >> 2 << 8 6 8 8
    7 8 >> 2 << 8 5 6 6
    4 5 6 5 4 3
    3 5 5 2 
    3 4 5 6 7 8 7 6 5
    3 1 5
    << 6 6 >> 1 1
48
;

: stairway
  cstd
  4 5 6% 5 4 5 
  4 5 6% 7% 6% 5
  6% 7% 8 7% 6% 5 4 3% 3% 4 4
  4  4 >> 1# << 8
29
;  

\ abba I have a dream
: dream
    5flats ." Switching to D% major (5-flats) scale" cr 1000 ms
1 6 5 7
1 4 3 4
1 6 5 7 
5 4 3 4
6 7 8 >> 2 1 << 5 
5 6 7 8 6
6 7 8 >> 2 << 8 5
5 6 7 8 6
>> 1 2 3 4 3 << 7
7 8 >>  2 3 2 1 << 7 6 8 8 
>> 1 2 3 4 3 << 7 
7 8 >> 2 3 2 1 << 7 6 8 8 
1 6 5 7
1 4 3 4
90
; 

\ YU -- I see Fire by Ed Sheeran


\ TRADITIONAL

: daffodils
    cstd
    4 4 3 2 3 
    5 5 4 3 4 5 
    6 6 5 4 6
    7% 7% 6 5 6 7%
    8 8 7% 6 4 7% 6 5 4 3 
    1 2 3 4 4 3 2 2 2 5 5 4 3
    1 2 3 4 4 3 2 2 2 5 5 4 3
58
;

: scarborough
  cstd
  1 1 5 5 5 2 3% 2 1 
  5 7% 8 7% 5 6 4 5
  8 8 8 7% 5 5 4 3% 2 << 7% >>
  1 5 4 3% 2 1 << 7% 8 >>
39
;  

\ ETHNOMUSIC

: sea
  cstd
  1 1 5  5 6 4 5
  1 1 5  5  6 4 8 7% 6 5
  >> 1 2 3% 4 3% 2
  1 1 2 3% 4 3% 5
  <<
  1 1 5  5 6 4 5
  1 1 5  5  6 4 8 7% 6 5
48
;


\  PERSONAL COMPOSITIONS

: dreaming  \  by Meera Shah Ebrahim 2021-05-16---Sun---21:34
cstd
>> 1 2 3 3  1 2 3 3  1 2 3 2 1 << 7 
7 8 >> 2 2  << 7 8 >> 2 2  7 8 >> 2 3 2 1
3 2 1 1 << 3 2 1 1  3 2 1 2 1 << 7 
7 >> 1 2 2  << 5 7 >> 2 2 << 5 7 >> 2 3 2 1
69
;

: tog   \ Together, by Jasmine Sheherazade Ebrahim
cstd
8  7  8 7 8 7 8 6 6
7  6  7 6 7 6 7 5 5
6  5  6 5 6 5 6 4 4
5  4  3 8 8 3 4
34 
;

: snake  \ Snake Charmer, by Assad Ebrahim
cstd
 1  3  4 5 
 5  6% 5 6% 4  5
 1  3 4 5 
 3  4 3 4 3 1
   
 1  3 4  5 
 5  6% 7% 6% 5 4 5
 4  3 4 3 4 3 1
 
 7% 6%  7% 6%  7% 6%  5 4  5 
 1 3 4 5
 3 4 3 4 3 4 3 1 
28
;


: planets  \  Planets, by Assad Ebrahim - 2020-07-10---Fri---03:32
cstd
 3 5 6 
 3 5 6 8 7 6 5 6 
 11
;


: jimmy-boy  \ Jimmy Boy, by Assad Ebrahim  2020-07-15---Wed---03:38
 cmaj
 1 2 3 5    5 6 5 4 5       \ oh jimmy-boy!  where are you running?
 1 2 3 5    5 4 3 3 4       \ oh jimmy-boy!  what have you done?
 1 2 3 5    5 6 5 4 5       \ oh jimmy-boy!  where will you run to?
 1 2 3 4    4 5 4 3 2 3     \ oh jimmy-boy!  I fear your time has come.
37 
;

\ Assad Ebrahim - 2021-05-12---Wed---05:18
: falling
cstd
cr ." Falling Down, by Assad Ebrahim"
\ this uses the pentatonic scale  5_ 7_ 1 2 4 5    g b c d f 
  2 5 4 2 1 2        \ the walls came tumbling down
  << 8 7 8 7 8 7 5 >>  \ falling, falling, falling down 
\ can also shift to start on g
  5 8 7 5 4 5 
  4 3 4 3 4 3 1
28
;


\ CHILDRENS

: doh
cstd
    1 2 3 1 3 1 3
    2 3 4 4 3 2 4
    3 4 5 3 5 3 5
    4 5 6 6 5 4 6
    5 1 2 3 4 5 6
    6 2 3 4 5 6 7
    7 3 4 5 6 7 8
    8 7 6 4 7 5 8
    1 2 3 4 5 6 7 8
64
;

: twinkle
cstd
    1 1 5 5 6 6 5 
    4 4 3 3 2 2 1
    5 5 4 4 3 3 2 
    5 5 4 4 3 3 2
    1 1 5 5 6 6 5
    4 4 3 3 2 2 1
    42
;    \ then play, watch or learn


\ mary had a little lamb
: mary
cstd
    3 2 1 2 3 3 3
    2 2 2
    3 5 5
    3 2 1 2 3 3 3  1 2 2 3 2 1
    26 ;

: alouette 
cstd    1 2 3 3 
    2 1 2 3 1 << 5 >>  
    1 2 3 3 
    2 1 2 3 1 << 5 >>
    1 2 3 4 5 5 5 
    5 6 5 4 3 2 1
    5 5 5 
    1 1 1
    5 5 5
    1 1 1
    5 4 3 2  \ repeat
54
;


: row-row
cstd
    1 1 1 2 3 
    3 2 3 4 5
    8 8 5 5 3 3 1 1
    5 4 3 2 1
23
; 

: london-bridge
cstd
    5 6 5 4 3 4 5 
    2 3 4   3 4 5
    5 6 5 4 3 4 5 
    2 5 3 1
24
;

\ jack and jill

: weasel  \ pop goes the weasel?
cstd
    1 1 2 2 3 5 3 1
       1 1 2 2 3 1 
    1 1 2 2 3 5 3 1
    6 2 4 3 1
27
;
    
\ little bo peep

\ baa baa black sheep
: baa
cstd
  1 1 5 5 6 7 8 6 5
  4 4 3 3 2 2 1 
  5 5 5 4 4 4 3 3 3 2
  1 5 5 5 4 5 6 4 3 2 2 1
38
;

: lavender \ lavender blue
cstd
  1 5 5 5 4 3 2 1   1 6 6 6 
  1 5 5 5 4 3 2 1   4 3 2 1
  
  1 5 5 5 4 3 2 1   1 6 6 6 
  1 5 5 5 4 3 2 1   4 3 2 1

  1 5 5 5 4 3 2 1   1 6 6 6 
  1 5 5 5 4 3 2 1   4 3 2 1
  
  1 5 5 5 4 3 2 1   1 6 6 6 
  1 5 5 5 4 3 2 1   4 3 2 1
96
;

: frere \ frere jacques
cstd
     1 2 3 1   1 2 3 1  
     3 4 5     3 4 5
     5 6 5 4 3 1   5 6 5 4 3 1 
     1  << 5 8  8 5 8 >>
34
;

: cockles \   cockles and mussels
cstd
    << 5 >> 1 1 1 1 3    1 1 2 2 2 2 4
    3 3 3 5 4 3   3 2 1 2 
    << 5 5 >> 1 1 1 1 3    1 2 2 2 2 4
    3 1 5 3   1  5 3  
    1 2 3 2 1
52
;

: robin-hood
cstd
    2 2 2 3 4 5 5 5 
    6 7 8 5 5 6 5 4 3 1 
    5 1 1 1 3 4 5 5 5 
    6 7 8  5 5 6 5 4 3 1
    5 6 6 6 5 4 3 4 5 6 5 
    5 6 8 5 5 6 5 4 3 1
58
;

\ bonnie lies over the ocean
: bonnie
cstd
    1 6 5 4 5 4 2 1 << 6 >>
    1 6 5 4 4 3 4 5 
    1 6 5 4 5 4 2 1 << 6 >>
    1 2 5 4 3 2 3 4 
    
    1 4  3 2 5  4 3 3 3 3 2 3 4  5 6 
    1 4  3 2 5  4 3 3 3 3 2 3 4 
66
;

\ old macdonald


: uk-anthem  \ god save the queen
cstd
    4 4 5 3 4 5
    6 6 7% 6 5 4 
    5 4 3 4 
    4 5 6 7%
    8 8 8 8 7% 6 
    7% 7% 7% 7% 6 5
    6 7% 6 5 4 6 7% 8 
    >> 2 << 7% 6 5 4
47
; 


\ AMERICAN FOLK SONGS

\ swing low sweet chariot
: chariot
cstd
    6 4 6 4 4 2 1 
    4 4 4 5 6 6 8 8
    >> 2 << 8 6 8 4 4 2 1 
    4 4 4 5 6 6 5 4
33
;

\ yankee doodle

\ michael finnegan
: finnegan
cstd
    1 4 4 4 4 6 8 8 6 5 4
    5 5 5 5 4 5 3 2 1
    4 4 4 4 6 8 8 6 5 4
    5 5 1 1 4 4 4  4 4 4 4
41
;

\ o give me a home (home on the range)
: home
cstd
  1 1 4 5 6
  4 3 2 7% 7% 7%
  6 7% 8 4 4 4 3 4 5 
  1 1 1 4 5 6
  4 3 2 7% 7% 7%
  7% 7% 6 5 4 3 4 5 4
  
  8 7% 6 5 6
  1 1 4 4 4 4 3 4 5
  1 1 1 4 5 6
  4 3 2 7% 7% 7%
  7% 7% 6 5 4 3 4 5 4
76
;

\ america the beautiful

\ star spangled banner
: USA
cstd
    8 6 4 6 8 >> 4
    6 5 4 << 
    6 7% 8
    8 8 >> 6 5 4 3 
    2 3 4 4 1 << 6 4 
    8 6 4 6 8 >> 4 
    6 5 4 << 6 7% 8
    8 8 >> 6 5 4 3 
    2 3 4 4 1 << 6 4
    >> 6 6 6 7% 8 8 
    7% 6 5 6 7% 7%
    7% 6 5 4 3
    2 3 4 << 6 7% 8
    8 >> 4 4 4 3 2 2 2   5 6 7% 6 5 4 4 3 
    1 1 4 5 6 7% 8 
    4 5 6 7% 5 4
113
;     
    
\ drunken sailor

\ o susanna
: susanna
cstd
    4# 5# 6# >> 1# 1# 2# 1# << 6# 4# 5# 6# 6# 5# 4# 5#
    4# 5# 6# >> 1# 1# 2# 1# << 6# 4# 5# 6# 6# 5# 5# 4#
34
;    

\ she'll be coming round the mountain
: mountain
cstd
    1# 2#   4# 4# 4# 4#  2# 1# 1# 2# 4#
    4# 5#   6# 6# 6# 6# 8# 6# 5# 4# 5#
    8# 8# 6# 6# 6# 6# 5# 4# 4# 4#
    2# 2# 2# 2# 6# 6#
    6# 6#   6# 6# 6# 6# 5# 5# 6# 5# 4#
49
;

\ naussau

\ oh bury me not
: cowboy  \ cowboys lament, folk song, johnny cash : https://en.wikipedia.org/wiki/Bury_Me_Not_on_the_Lone_Prairie
cstd
\ alt: Chinese yu scale
  1 3% 3% 5 7%
  8 7% 5 3% 5
  1 1 3% 5 4 
  5 4 3% 1 3%
20
;  

: betsy  \ sweet betsy from pike
cstd
  1 1 3 5 5 4 2 2 1 << 7 >> 1
  1 1 3 5 8 8 8 8 5 5 5
  5 8 8 8 7 5 3 4 5 6 5
  1 2 3 3 3 5 4 2 2 1 << 7 >> 1
49
; 

: smokey
cstd
  1 1 3 5 8 6
  6 4 5 6 5
  1 1 3 5 5 2 
  3 4 3 2 1

  1 1 3 5 8 6
  6 4 5 6 5
  1 1 3 5 5 2 
  3 4 3 2 1
44
;

: room  \ beach boys
cstd
  2 2 3 2 4# 4# 5 4# 6 6 7 5 6
  6 4# 3  5 4# 2
19
;
   

: green-day
cstd
  5 7 8 7   5 7 8 7   5 7 8 7  5 5
14
;

: star-wars
cstd
  1 5 4 3 2 8 5   4 3 2 8 5   4 3 4 2
  1 1 5 4 3 2 8 5   4 3 2 8 5   4 3 4 2
33 
;

: top-gun
cstd
  1 5 5 4 3 4 3 2 2 1 2 3 2 3 4 3 1 3 2
1 1 5 5 4 3 4 3 2 2 1 2 3 2 3 4 3 1 5
  1 2 3 4 5 6 7 >>
  1 5 5 4 3 4 3 2 2 1 2 3 2 3 4 3 1 3 2
1 1 5 5 4 3 4 3 2 2 1 2 3 2 3 4 3 1 5
84
;

: bday
cstd
    1 1 2 1 4 3
    1 1 2 1 5 4 
    1 1 8 6 4 3 2
    7% 7% 6 3 5 4
25
;

\ axle-f

\ chopstix

: silent-night
cstd
    4 5 4 2 
    4 5 4 2
    7% 7% 5 6 6 4
    5 5 7% 6 5 4 5 4 2
    5 5 7% 6 5 4 5 4 2
    >> 1 1 3% 1 << 6 7% >> 2
    << 7% 4 2 4 3% 1 << 7%
51
;

\ ======================================

: help-songlist
cr 
cr ." HELP-SONGLIST"
cr ." -------------"
cr ." by Assad Ebrahim - http://www.mathscitech.org/articles"
cr 
cr ." includes: 3iForth.fs [3iLight.fs] 3iPort-4x4.fs 3iSound-4x4.fs 3iPiano.fs 3iSonglist.fs"
cr ." init: 1 open-com  13 start-speaker init-shiftout INIT-PIANO"
cr ." songlist: <songname> play | watch | learn"
cr ." help-songs"
cr 
;

help-songlist

\ V3 - 2021-05-16---Sun---17:14 - perfected the multi-octave notation with << and >> mapping to [<<] and [>>]
\ V4 - 2021-08-11---Wed---06:28 - MAJOR - perfected integration with 32-key piano lights board and different key signatures (ethnoscales), fixed songlist
